# Dataliner by Bytebreaker of Hokuto Force (Vincent Truppe) in March 2019
# Conversion to python 3 by Wil, also in March 2019

# python dataliner.py Z:/output.txt Z:/qspb.prg Z:/data.txt 9500

# Zuerst die Zeilen in der Datei output.txt zaehlen und davon 2 abziehen (die Adressbytes ganz am Anfang) um die Anzahl Bytes zu kennen, die als Datas gepoked werden sollen. 
# Byte-Laenge = Anzahl Zeilen in output.txt - 2
# Wenn man die Datas in C64 Basic einliest, dann immer von Startadresse bis Startadresse + Byte-Laenge - 1 einlesen.
# Beispiel:
# Programmumfang: 6 Bytes
# Startadresse: 49152
# Dann: 49152 bis 49152 + 5 einlesen

import sys
import os

print

if len(sys.argv)<4:
    print ("Bitte alle Argumente vollstaendig angeben:")
    print ("python dataliner.py datei.prg data.txt start-zeilennr.")
    sys.exit()

count3 = 0

m = open('output.txt', "w") # "C:/Users/truppe/Desktop/VT_ProSeS/portable/Python/output.txt"

with open(sys.argv[1], "rb") as f: # "C:/Users/truppe/Desktop/VT_ProSeS/portable/Python/qspb.prg"
    byte = f.read(1)  
    while byte != b'':
        print (int.from_bytes(byte, byteorder='little'),file=m)
        byte = f.read(1)
        count3 += 1
    print("closing")
m.close()

count = 0
count2 = 0
i = 2  # Die ersten beiden Adressbytes des C64 PRGs fliegen raus
j = 0
k = 0
l = int(sys.argv[3])
f = open('output.txt')

zeilen = f.readlines()
n1=hex(int(zeilen[0]))
n2=hex(int(zeilen[1]))
loadadr = str(n2+n1)
loadadr = loadadr[1:]
loadadr = "$" + loadadr.replace("x", "")
loadadr = loadadr[0:3] + loadadr[-2:] 
loadadr2 = int(zeilen[1]) * 256 + int(zeilen[0])

f.close()
f = open('output.txt')

for line in f : count += 1 # zur Sicherheit immer '/' sonst \t oder \p Steuerzeichen (Tab)
f.close()
g = open('output.txt')
h = open(sys.argv[2],'w+') # 'C:/Users/truppe/Desktop/VT_ProSeS/portable/Python/data.txt'

lines = g.readlines()

if count3 < 19:
	print ("Abbruch. Binaerfile zu klein!")
	sys.exit()

while i <= count:
        print ( str(l) + " " + "data" + " " + lines[i].strip('\n')+","+lines[i+1].strip('\n')+","+lines[i+2].strip('\n')+","+lines[i+3].strip('\n')+","+lines[i+4].strip('\n')+","+lines[i+5].strip('\n')+","+lines[i+6].strip('\n')+","+lines[i+7].strip('\n')+","+lines[i+8].strip('\n')+","+lines[i+9].strip('\n')+","+lines[i+10].strip('\n')+","+lines[i+11].strip('\n')+","+lines[i+12].strip('\n')+","+lines[i+13].strip('\n')+","+lines[i+14].strip('\n')+","+lines[i+15].strip('\n'), file=h)
        i += 16
        l += 1
        if i >= count-16:
                count2 = count - i
                break
                
j = count - count2

while j <= count-2:
        print (str(l) + " " + "data" + " " + lines[j].strip('\n'), file=h)
        j += 1
        l += 1

print (str(l) + " " + "data" + " " + lines[count-1].strip('\n'), file=h)

print ("Anzahl Bytes im DATA-Stream abzgl. erste 2 Address-Bytes: " + str(count3-2))
print ("Datei laedt im C64 bei " + loadadr)
print ("Am C64 einlesen von " + str(loadadr2) + " bis " + str(loadadr2) + " + " + str(count3-3))
print ("Ablageort DATA-Datei:   " + sys.argv[2])

f.close()
g.close()
h.close()
m.close()

os.remove('output.txt')
print






